//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, TrendLaboratory"
#property copyright "pdf and confidence bands  mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_color2 clrDeepSkyBlue
#property indicator_color3 clrSandyBrown
#property indicator_color4 clrDeepSkyBlue
#property indicator_color5 clrSandyBrown
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT

//---- input parameters
extern int     Length      = 10;      // Volty Length
extern double  Kv          = 5;       // Sensivity Factor
extern int     StepSize    = 10;      // Constant Step Size (if need)
extern double  Variance    = 0.4;
extern double  Mean        = 0.0;
extern int     MA_Mode     = 1;       // Volty MA Mode : 0-SMA, 1-LWMA 
extern int     Advance     = 0;       // Offset
extern double  Percentage  = 0;       // Percentage of Up/Down Moving
extern double  UpDownShift = 0;       // Number of Up/Down Moving, in points. For ColorMode==3 only.
extern bool    HighLow     =true;   // High/Low Mode Switch (more sensitive)
extern int     ColorMode   = 2;       // Color Mode Switch
extern int     BarsNumber  = 0;       
extern double ConfidenceLevel      = 95;
extern int    ConfidenceBandsShift = 0;

//---- indicator buffers
double LineBuffer[];
double UpBuffer[];
double DnBuffer[];
double smin[];
double smax[];
double trend[];
double  coeffs[];
double cbu[],cbd[];

double StepMA=0, ATR0=0,ATRmax=-100000,ATRmin=1000000;
int limit;

//---- StepSize Calculation

   double StepSizeCalc ( int Len, double Km, int Size, int k)
   {

   double result;
   if( Size==0 ) 
   {
        double AvgRange=0;
	     double Weight = 0;
	     for (int i=Len-1;i>=0;i--)
	     { 
            if(MA_Mode==0) double alfa= 1.0; else alfa= 1.0*(Len-i)/Len; 
            AvgRange+= alfa*(High[k+i]-Low[k+i]);
            Weight += alfa;
        }
	     ATR0 = AvgRange/Weight;
	
	if (ATR0>ATRmax) ATRmax=ATR0;
	if (ATR0<ATRmin) ATRmin=ATR0;
	
	result=MathRound(0.5*Km*(ATRmax+ATRmin)/Point); 
	}
	else
	result=Km*StepSize;
   
   return(result);
   }

//---- StepMA Calculation   
   
   double StepMACalc (int tLength, bool HL, double Size, int k)
   {
   int counted_bars=IndicatorCounted();
   double result;
   
   if (HL)
	  {
	  smax[k]=iPdfma(Low[k] ,tLength,coeffs,k,0)+2.0*Size*Point;
	  smin[k]=iPdfma(High[k],tLength,coeffs,k,1)-2.0*Size*Point;
     } 	
	else  	 
	  {
	  smax[k]=iPdfma(Close[k],tLength,coeffs,k,0)+2.0*Size*Point;
	  smin[k]=iPdfma(Close[k],tLength,coeffs,k,0)-2.0*Size*Point;
	  }
	  if (counted_bars==0){smax[limit+1]=smax[limit];smin[limit+1]=smin[limit];trend[limit+1]=0;}
	  
	  trend[k]=trend[k+1];   
	  
	  if (Close[k]>smax[k+1]) trend[k]=1;   
	 
	  if (Close[k]<smin[k+1]) trend[k]=-1;  
	 
	  if(trend[k]>0)
	  {
	  if(smin[k]<smin[k+1]) smin[k]=smin[k+1];
	  result=smin[k]+Size*Point;
	  } 
	  else
	  {
	  if(smax[k]>smax[k+1]) smax[k]=smax[k+1];
	  result=smax[k]-Size*Point;
	  }
     //Print (" k=",k," trend=",trend[k], " res=",result," Smax=", smax[k], " Smin=", smin[k]);
	  
     
     return(result); 
     } 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#define maxx 3.5
double ConfidenceT;
  int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(8);
   
//   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   
   SetIndexArrow(1,159);
   SetIndexArrow(2,159);
   
   SetIndexBuffer(0,LineBuffer);
   SetIndexBuffer(1,UpBuffer);
   SetIndexBuffer(2,DnBuffer);
   SetIndexBuffer(3,cbu);
   SetIndexBuffer(4,cbd);
   
   SetIndexShift(0,Advance);
   SetIndexShift(1,Advance);
   SetIndexShift(2,Advance);
   
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,smax);
   SetIndexBuffer(7,trend);
   
//---- name for DataWindow and indicator subwindow label
   short_name="StepMA("+Length+","+Kv+","+StepSize+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"DownTrend"); 
//----
   SetIndexDrawBegin(0,Length);
   SetIndexDrawBegin(1,Length);
   SetIndexDrawBegin(2,Length);
//----

      ArrayResize(coeffs,Length);   
         double step = maxx/(Length-1); for(int i=0; i<Length; i++) coeffs[i] = pdf(i*step,Variance,Mean*maxx);

         ConfidenceLevel   = MathMax(MathMin(ConfidenceLevel,99.9999999999),0.0000000001);
         ConfidenceT       = InverseStudentsT(ConfidenceLevel,Length-1);
   return(0);
   }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }     
//+------------------------------------------------------------------+
//| StepMA_v7.2                                                        |
//+------------------------------------------------------------------+
int start()
{
   int shift, counted_bars=IndicatorCounted();
     
   if ( BarsNumber > 0 ) int Nbars=BarsNumber; else Nbars=Bars;
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Nbars-Length-1; 
     
   for(shift=limit;shift>=0;shift--) 
   {	
     
      int Step = StepSizeCalc( Length, Kv, StepSize, shift);
				
      Comment (" StepSize= ", Step);
	
   	StepMA = StepMACalc ( Length, HighLow, Step, shift)+Percentage/100.0*Step*Point;
	
   	if ( ColorMode == 0) LineBuffer[shift]=StepMA;
	
   	if ( ColorMode == 1)
   	{
         if ( trend[shift]>0 )
         {
            UpBuffer[shift]=StepMA-Step*Point;
            LineBuffer[shift]= UpBuffer[shift];
            DnBuffer[shift]=EMPTY_VALUE;
         }
         else
         if ( trend[shift]<0 )
         {
            DnBuffer[shift]=StepMA+Step*Point;
            LineBuffer[shift]= DnBuffer[shift];
            UpBuffer[shift]=EMPTY_VALUE;
         }
      }
      else
      if ( ColorMode == 2)
      {
         if (trend[shift]>0) 
         {
            UpBuffer[shift]=StepMA+UpDownShift*Point;
            if ( trend[shift+1] < 0 ) UpBuffer[shift+1] = DnBuffer[shift+1];
            LineBuffer[shift]= UpBuffer[shift];
            DnBuffer[shift]=EMPTY_VALUE;
         }
         if (trend[shift]<0) 
         {
            DnBuffer[shift]=StepMA-UpDownShift*Point;
            if ( trend[shift+1] > 0 ) DnBuffer[shift+1] = UpBuffer[shift+1];
            LineBuffer[shift]= DnBuffer[shift];
            UpBuffer[shift]=EMPTY_VALUE;
         }
      }//end if ( ColorMode == 2)
      else
      if ( ColorMode == 3)
   	{
         if ( trend[shift]>0 )
         {
            UpBuffer[shift]=StepMA+(Step+UpDownShift)*Point;
            LineBuffer[shift]= UpBuffer[shift];
            DnBuffer[shift]=EMPTY_VALUE;
         }
         else
         if ( trend[shift]<0 )
         {
            DnBuffer[shift]=StepMA-(Step+UpDownShift)*Point;
            LineBuffer[shift]= DnBuffer[shift];
            UpBuffer[shift]=EMPTY_VALUE;
         }
      }//end if ( ColorMode == 3)
      else
      {	
         LineBuffer[shift]=StepMA;
         UpBuffer[shift]=EMPTY_VALUE;
         DnBuffer[shift]=EMPTY_VALUE;
      }
	
   }//end for(shift=limit;shift>=0;shift--) 
   for(int i=limit;i>=0;i--) 
   {	
      double dev = iDeviation(LineBuffer,Length,LineBuffer[i+ConfidenceBandsShift],i+ConfidenceBandsShift);
      double me  = ConfidenceT*dev/MathSqrt(Length);
      cbu[i] = LineBuffer[i+ConfidenceBandsShift]+me;
      cbd[i] = LineBuffer[i+ConfidenceBandsShift]-me;
   }
	return(0);	
 }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//    normal probability density function
//
//

#define Pi 3.141592653589793238462643

double pdf(double x, double variance=1.0, double mean=0)
      { return((1.0/MathSqrt(2*Pi*MathPow(variance,2))*MathExp(-MathPow(x-mean,2)/(2*MathPow(variance,2))))); }

//
//
//
//
//

double workPdfma[][2];
double iPdfma(double price, double period, double& tcoeffs[], int r, int instanceNo=0)
{
   if (ArraySize(workPdfma)!= Bars) ArrayResize(workPdfma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workPdfma[r][instanceNo] = price;
      double sumw = tcoeffs[0];
      double sum  = tcoeffs[0]*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = tcoeffs[k];
                sumw  += weight;
                sum   += weight*workPdfma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double HillsInverseT(double p, double df) 
{
   if (df == 1) return(MathCos(p*Pi/2.0)/MathSin(p*Pi/2.0));
   if (df == 2) return(MathSqrt(2.0/(p*(2.0 - p))-2.0));
   
   //
   //
   //
   //
   //
   
      double a = 1.0/(df - 0.5);
	   double b = 48.0/(a*a);
	   double c = ((20700.0*a/b - 98.0)*a - 16.0)*a + 96.36;
	   double d = ((94.5/(b + c)-3.0)/b + 1.0)*MathSqrt(a*Pi*0.5)*df;
	   double x = d*p;
	   double y = MathPow(x,2.0/df);
	   double t;
	    
	   if (y > 0.05 + a)
	   {
	     x = NormalZ(0.5*(1.0-p));
		  y = x*x;
            if (df < 5) c = c + 0.3*(df - 4.5)*(x + 0.6);
                        c = (((0.05*d*x - 5.0)*x - 7.0)*x - 2.0)*x + b + c;
                        y = (((((0.4*y + 6.3)*y + 36.0)*y + 94.5)/c - y - 3.0)/b + 1)*x;
                        y = a*y*y;
                        if (y > 0.002) 
                              y = MathExp(y) - 1.0;
                        else  y = 0.5*y*y + y;
         t = MathSqrt(df*y);
	   }
	   else 
      {
		    y = ((1.0/(((df + 6)/(df*y) - 0.089*d - 0.822)*(df + 2)*3)+ 0.5/(df + 4))*y - 1.0)*(df + 1.0)/(df + 2.0) + 1.0/y;
	       t = MathSqrt(df*y);
      }
     return(t);
}

//
//
//
//
//

double T_to_P(double t, double df) 
{
   double abst = MathAbs(t), tsq = t*t, p;
	  if      (df == 1) p = 1 - 2*MathArctan(abst)/Pi;
	  else if (df == 2) p = 1 - abst/MathSqrt(tsq + 2);
	  else if (df == 3) p = 1 - 2*(MathArctan(abst/MathSqrt(3)) + abst*MathSqrt(3)/(tsq + 3))/Pi;
	  else if (df == 4) p = 1 - abst*(1 + 2/(tsq + 4))/MathSqrt(tsq + 4);
	  else {
	        double z = T_to_Z(abst,df);
                  p = NormalP(z);
          }
    return(p);
}

//
//
//
//
//

double T_to_Z(double t, double df)
{
   double a = df - 0.5;
   double b = 48*a*a;
   double c = t*t/df, x, p, q, z;

   if (c >= 0.04) 
         x = a*MathLog(1.0+c);
	else  x = a*(((1 - c*0.75)*c/3 - 0.5)*c + 1)*c;
         p = ((0.4*x + 3.3)*x + 24)*x + 85.5;
         q = 0.8*MathPow(x, 2) + 100 + b;
         z = (1 + (-p/q + x + 3)/b)*MathSqrt(x);
	return(z);
}

//
//
//
//
//

double NormalZ(double p)
{
    static double a[4]={ 2.50662823884,-18.61500062529,41.39119773534,-25.44106049637};
    static double b[4]={-8.47351093090,23.08336743743,-21.06224101826,3.13082909833};
    static double c[4]={-2.7871893,-2.2979648,4.8501413,2.3212128};
    static double d[2]={ 3.5438892,1.6370678 };

    if (p>0.42) 
    {
      	double r = MathSqrt(-MathLog(0.5-p));
	      double z = (((c[3]*r+c[2])*r+c[1])*r+c[0])/((d[1]*r+d[0])*r+1.0);
    }
    else
    {
	     r = p*p;
	     z = p*(((a[3]*r+a[2])*r+a[1])*r+a[0])/((((b[3]*r+b[2])*r+b[1])*r+b[0])*r+1.0);
    }
    return(z);
}

//
//
//
//
//

double NormalP(double z)
{
    static double a[6] = { 0.0000053830, 0.0000488906, 0.0000380036, 0.0032776263, 0.0211410061, 0.0498673470};

    double absz = MathAbs(z);
    double p = (((((a[0]*absz+a[1])*absz+a[2])*absz+a[3])*absz+a[4])*absz+a[5])*absz+1.0;
           p = MathPow(p,-16);
    return(p);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double InverseStudentsT(double probability, double degreeOfFreedom)
{
   probability = (100.0-probability)/100.0;
   
     double df   = MathMax(degreeOfFreedom,1);
     double p    = MathMax(MathMin(probability,1),0);
	  double pw   = p;
	  double diff = 1;
	  double t    = 0;

      //
      //
      //
      //
      //
      
      while (MathAbs(diff) > 0.0001)
      {
   	     t    = HillsInverseT(pw, df); // initial rough value
	        diff = T_to_P(t,df) - p;      // compare result with forward fn
	        pw  -= diff;                  // small adjustment to pw
      }
  return(t);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double iDeviation(double& array[], double period, double ma, int i, bool isSample=true)
{
   double sum = 0.00; for(int k=0; k<period; k++) sum += MathPow((array[i+k]-ma),2);
   if (isSample)      
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}